Video Encoder and Decoder in IMX7

cancel
Showing results for 
Search instead for 
Did you mean: 

Video Encoder and Decoder in IMX7

Jump to solution
2,020 Views
gopinathsriniva
Contributor III

Hello Everyone,

From the I.MX7 block diagram I understand that I.MX7 does n't have any hardware/hardware-accelerated video codec. I want to add software video codec support in the YOCTO build. May I know, is there any software video encoders/decoders already supported in I.MX7 sabresd? If yes, can you give the details and steps to test it ? If no, Can anyone guide me, how to add software codec support in yocto build? 

Your suggestions are appreciated. Thank-You.

Regards,

Gopinath 

Labels (2)
0 Kudos
1 Solution
674 Views
joanxie
NXP TechSupport
NXP TechSupport

For software encoding and decoding of H.264, the following changes needed to be added:
build/conf/local.conf
CORE_IMAGE_EXTRA_INSTALL += “gstreamer1.0-plugins-ugly-meta packagegroup-fsl-gstreamer1.0-commercial gst-ffmpeg”
LICENSE_FLAGS_WHITELIST += “commercial”

View solution in original post

0 Kudos
6 Replies
674 Views
marco_antonio_franchi
NXP Employee
NXP Employee

Hi Gorinaph,

You can try this post: Encoding and decoding H.264 without VPU - i.MXDev Blog 

I think you are missing the ".bbappend" in the process.

I hope it can be useful.

Marco Franchi

674 Views
gopinathsriniva
Contributor III

Hi Marco,

Thank You. I will check it and let you know. 

0 Kudos
675 Views
joanxie
NXP TechSupport
NXP TechSupport

For software encoding and decoding of H.264, the following changes needed to be added:
build/conf/local.conf
CORE_IMAGE_EXTRA_INSTALL += “gstreamer1.0-plugins-ugly-meta packagegroup-fsl-gstreamer1.0-commercial gst-ffmpeg”
LICENSE_FLAGS_WHITELIST += “commercial”

View solution in original post

0 Kudos
674 Views
gopinathsriniva
Contributor III

Hi Joan Xie,

It seems gst-ffmpeg is not available in gstreamer1.0 plugins. Because

"bitbake -s | grep gst-ffmpeg" output shows none. 

By the way, I tried adding "CORE_IMAGE_EXTRA_INSTALL += "gstreamer1.0-plugins-ugly" to the image. But still I cannot find H.264 encoder in the gst-insptect command.

Below is the output of "gst-inspect-1.0 | grep h264" command


uvch264: uvch264mjpgdemux: UVC H264 MJPG Demuxer
uvch264: uvch264src: UVC H264 Source
libav: avdec_h264: libav H.264 / AVC / MPEG-4 AVC / MPEG-4 part 10 decoder
typefindfunctions: video/x-h264: h264, x264, 264
rtp: rtph264depay: RTP H264 depayloader
rtp: rtph264pay: RTP H264 payloader
videoparsersbad: h264parse: H.264 parser

Any suggestions? 

0 Kudos
674 Views
joanxie
NXP TechSupport
NXP TechSupport

why don't you miss the parameter "packagegroup-fsl-gstreamer1.0-commercial gst-ffmpeg" ??

0 Kudos
674 Views
gopinathsriniva
Contributor III

Hi Joan,

When I tried the below changes, 

CORE_IMAGE_EXTRA_INSTALL += “gstreamer1.0-plugins-ugly-meta packagegroup-fsl-gstreamer1.0-commercial gst-ffmpeg”
LICENSE_FLAGS_WHITELIST += “commercial” 

I got the below errors. 

NOTE: Resolving any missing task queue dependencies
ERROR: Nothing RPROVIDES 'gst-ffmpeg' (but /home/gopinath/projects/linux/esomimx7/fsl-release-bsp/sources/meta-fsl-bsp-release/imx/meta-sdk/recipes-fsl/images/fsl-image-gui.bb RDEPENDS on or otherwise requires it)
ERROR: gst-ffmpeg was skipped: Recipe is blacklisted: Not compatible with currently used ffmpeg 3
NOTE: Runtime target 'gst-ffmpeg' is unbuildable, removing...
Missing or unbuildable dependency chain was: ['gst-ffmpeg']
ERROR: Required build target 'fsl-image-gui' has no buildable providers.
Missing or unbuildable dependency chain was: ['fsl-image-gui', 'gst-ffmpeg']

that's why I checked with "gstreamer1.0-plugins-ugly" alone and with this I have managed to get H264 decoder. 

Also I have checked with skipping gst-ffmpeg. Same results as gstreamer1.0-plugins-ugly. (i.e only h264 decoder is enabled).

So can you please tell me how to add h264 encoder support? 

Thanks,

Gopinath S

0 Kudos